       subroutine enpo(na,ipoint,ijpoint)
      implicit real*8(a-h,o-z)
      parameter (nmax=1000)
      parameter (maxat=100)
      parameter (maxat1=101)
      parameter (ndeckl=1000)
      parameter (mmax= 40 000 000)
      parameter (mgmax=12 000 000)
      dimension na(maxat),sam(ndeckl,ndeckl)
      dimension ea(maxat),eab(maxat,maxat),h(ndeckl,ndeckl)
      dimension pa(ndeckl,ndeckl),pb(ndeckl,ndeckl)
      dimension ipoint(maxat),ijpoint(maxat,maxat)      
      common /large/aa(mmax),gg(mgmax),z(mmax),gt(mgmax)
      common /oneel/oneel,bsse
      common /nat/ nat,igr,ifg,nocc,nalf,nb,iuhf
      common /lim/ llim(nmax),iulim(nmax)
      common /c/ca(ndeckl,ndeckl),p(ndeckl,ndeckl)
      common /coord/ coord(3,maxat),zn(maxat),iatf(maxat)
      common /stv/ s(ndeckl,ndeckl),t(ndeckl,ndeckl),
     $             vv(ndeckl,ndeckl,maxat)
      common /opensh/ cb(ndeckl,ndeckl)

      nocca=nalf
      noccb=nb
      natoms=nat
      m=igr
      nbas=m

      oneel=0.d0
      bsse=0.d0
      
  56  format(10x,f5.2,3f20.20)
  61  format(1x,7f10.7)
 617  format(4i4)

      
      call pmop(ca,nocca,cb,noccb,nbas,pa,pb,ndeckl)
      call border(Pa,pb,S,llim,iulim,natoms,nbas)
      call inpint(gg,mgmax,natoms,llim,iulim)                   
      print *,'   '
      print 688
 688  format(80(1h-))
      print *,'   '
      nnab=(natoms*(natoms-1)/2)
      write(*,*)natoms,' ATOMS, ',nnab,' ATOMIC PAIRS'
      call inpint(gg,mgmax,natoms,llim,iulim)
      eonec=0.d0
      do 100 i=1,natoms 
      ip=ipoint(i)
      call atomicop(i,s,h,t,pa,pb,ndeckl,llim(i),na(i),sam,ea(i),
     $    z,nbas,natoms,gg(ip),aa)
c     write(*,*)' ATOM', i,' ATOMIC ENERGY CONTRIBUTION ',ea(i) 
 100  eonec=eonec+ea(i)     
      write(*,*)' '
      write(*,*)' '
      write(*,*)' SUM OF THE ONE-CENTER ENERGY COMPONENTS', eonec

      nat1=natoms-1
      etwoc=0.d0
      do 200 i=1,nat1 
      i1=i+1
      do 200 j=i1,natoms
      nnn=na(i)+na(j)
       ip=ijpoint(1,2)
       ipi=ipoint(i)
       ipj=ipoint(j)

      call pairsop(i,j,s,h,ndeckl,llim(i),na(i),llim(j),na(j),sam,
     $   nnn,eab(i,j),aa,pa,pb,t,z,m,natoms,gg(ip),gg(ipi),gg(ipj),gt)
c     write(*,*)' ATOMS', i,j,'TWO-CENTER EN. CONTRIBUTION ',eab(i,j) 
      eab(j,i)=eab(i,j)
 200  etwoc=etwoc+eab(i,j)  
      write(*,*)' '
      write(*,*)' SUM OF THE TWO-CENTER ENERGY COMPONENTS', etwoc
      econt=eonec+etwoc
       write(*,*)' '
      write(*,*)' '
      write(*,*)' SUM OF THE ONE AND TWO-CENTER COMPONENTS', econt
      do 66 i=1,natoms
  66  eab(i,i)=ea(i)

      write(*,*)' '
      write(*,*)' '
      Write(*,*)'          ENERGY COMPONENT MATRIX'
       write(*,*)' '
      call mprint(eab,natoms,maxat)
      end 


      subroutine atomicop(iat,s,h,t,pa,pb,ndeckl,llim,na,sam,ea,z,m,
     $  natoms, g,aa)
      implicit real*8(a-h,o-z)
      parameter (ndeck=1000)
      dimension s(ndeckl,ndeckl),h(ndeckl,ndeckl),sam(na,na)
      dimension t(ndeckl,ndeckl),pa(ndeckl,ndeckl),z(m,m,natoms)
      dimension ha(ndeck,ndeck),a(ndeck,ndeck),b(ndeck,ndeck)
      dimension aa(m,m,natoms),g(na,na,na,na),pb(ndeckl,ndeckl)
      dimension ca(ndeck,ndeck),cb(ndeck,ndeck)
      common /oneel/oneel,bsse
c    
      call invert1(s,ndeckl,sam,llim,na)
      do 1 i=1,m
      do 1 j=1,m
  1   ha(i,j)=t(i,j)+z(i,j,iat) 
  61  format(1x,8f9.6)
       do 11 i=1,m
       do 11 j=1,m
       b(i,j)=0.d0
       ca(i,j)=0.d0
       cb(i,j)=0.d0
  11   a(j,i)=0.d0       


      do 2 lambda=1,m
      do 2 mu0=1,na
      mu=llim+mu0-1 
      x=0.d0
      do 3 isigm0=1,na
      isigm=isigm0+llim-1 
  3    x=x+s(lambda,isigm)*sam(isigm0,mu0)
   2  a(lambda,mu)=x
    
      do 18 i=1,m
      do 18 j=1,m
  18  aa(i,j,iat)=a(i,j)

      do 4  mu0=1,na
      mu=llim+mu0-1 
      do 4  nu0=1,na
      nu=llim+nu0-1 
      x=0.d0
      y=0.d0
      do 5 igam=1,m
      y=y+pb(mu,igam)*a(igam,nu)
  5   x=x+pa(mu,igam)*a(igam,nu) 
      cb(mu,nu)=y
      ca(mu,nu)=x
  4   b(mu,nu)=x+y
 
      ea=0.d0
      do 6  mu0=1,na
      mu=llim+mu0-1 
      do 6  nu0=1,na
      nu=llim+nu0-1 
  6   ea=ea+b(nu,mu)*ha(mu,nu)
      oneel=oneel+ea
c      print *, ea
      et=0.d0
      do 7 kappa0=1,na
      kappa=llim+kappa0-1
      do 7 iro0=1,na
      iro=llim+iro0-1
      do 7 itau0=1,na
      itau=llim+itau0-1
      do 7 ieta0=1,na
      ieta=llim+ieta0-1
  7   et=et+g(itau0,ieta0,kappa0,iro0)*(b(kappa,itau)*b(iro,ieta)-
     $        ca(kappa,ieta)*ca(iro,itau) - 
     $        cb(kappa,ieta)*cb(iro,itau)) 
       
      ea=ea+0.5d0*et
      return
      end


      subroutine pairsop(ii,jj,s,h,ndeckl,llimi,ni,llimj,nj,sam,
     $   nnn,eabij,aa,pa,pb,t,z,m,natoms,gg,gi,gj,gt)
      implicit real*8(a-h,o-z) 
      parameter (maxat=100)
      parameter (ndeck=1000)
      dimension s(ndeckl,ndeckl),h(ndeckl,ndeckl),sam(nnn,nnn),
     $ pa(ndeckl,ndeckl),t(ndeckl,ndeckl),aa(m,m,natoms), 
     $ z(m,m,natoms),a(ndeck,ndeck),b(ndeck,ndeck),
     $  pb(ndeckl,ndeckl),ca(ndeck,ndeck),cb(ndeck,ndeck)
      dimension gg(nnn,nnn,nnn,nnn),gi(ni,ni,ni,nI),gj(nj,nj,nj,nj)
      dimension gt(nnn,nnn,nnn,nnn)
      common /oneel/oneel,bsse
      common /coord/ coord(3,maxat),zn(maxat),iatf(maxat)
      common /nat/ idum1,nbasis,idum2(5)
      common iop(45)

c
C  Statement function to form combination with the exchange part:

      p(i,j)=pa(i,j)+pb(i,j)
      pp(i,j,k,l)=p(i,j)*p(k,l)-pa(i,l)*pa(k,j)-pb(i,l)*pb(k,j)
      bb(i,j,k,l)=b(i,j)*b(k,l)-ca(i,l)*ca(k,j)-cb(i,l)*cb(k,j)
c
c
      do 7171 i=1,nnn
      do 7171 j=1,nnn
      do 7171 k=1,nnn
      do 7171 l=1,nnn
 7171   gg(l,k,j,i)=0.d0
      call shellab(ii,jj,nbasis,natoms)
      if(iop(7).ne.0)call unconab(ii,jj)
      call invert2(s,ndeckl,sam,llimi,ni,llimj,nj,nnn)
 
      iulimi=llimi+ni-1
      iulimj=llimj+nj-1

      ishift=llimi-1
      jshift=llimj-1-ni
      jshift0=llimj-1

       
   61 format(8f10.7)  
       do 11 i=1,m
       do 11 j=1,m
       b(j,i)=0.d0
       ca(j,i)=0
       cb(j,i)=0
  11   a(j,i)=0.d0


      do 12 lambda=1,m
      do 12 mu0=1,ni
      mu=llimi+mu0-1
      x=0.d0
      do 13 isigm0=1,ni 
      isigm=isigm0+llimi-1
  13    x=x+s(lambda,isigm)*sam(isigm0,mu0)
      do 14 isigm0=1,nj
      isigm=isigm0+llimj-1
  14   x=x+s(lambda,isigm)*sam(isigm0+ni,mu0)
  12  a(lambda,mu)=x
      do 22 lambda=1,m
      do 22 mu0=1,nj
      mu=llimj+mu0-1
      x=0.d0
      do 23 isigm0=1,ni 
      isigm=isigm0+llimi-1
  23    x=x+s(lambda,isigm)*sam(isigm0,mu0+ni)
      do 24 isigm0=1,nj 
      isigm=isigm0+llimj-1
  24   x=x+s(lambda,isigm)*sam(isigm0+ni,mu0+ni)
  22  a(lambda,mu)=x

      do 32 mu=llimi,iulimi
      do 33 nu=llimi,iulimi
      x=0.d0
      y=0.d0
      do 34 igam=1,m
      y=y+pb(mu,igam)*A(igam,nu)
  34  x=x+pa(mu,igam)*A(igam,nu)
      ca(mu,nu)=x
      cb(mu,nu)=y
  33  b(mu,nu)=x+y

      do 35 nu=llimj,iulimj
      x=0.d0
      y=0.d0
      do 36 igam=1,m
      y=y+pb(mu,igam)*A(igam,nu)
  36  x=x+pa(mu,igam)*A(igam,nu)
      ca(mu,nu)=x
      cb(mu,nu)=y
  35  b(mu,nu)=x+y
  32  continue

 
      do 42 mu=llimj,iulimj
      do 43 nu=llimi,iulimi
      x=0.d0
      y=0.d0
      do 44 igam=1,m
      y=y+pb(mu,igam)*A(igam,nu)
  44  x=x+pa(mu,igam)*A(igam,nu)
      ca(mu,nu)=x
      cb(mu,nu)=y
  43  b(mu,nu)=x+y

      do 45 nu=llimj,iulimj
      x=0.d0
      y=0.d0
      do 46 igam=1,m
      y=y+pb(mu,igam)*A(igam,nu)
  46  x=x+pa(mu,igam)*A(igam,nu)
      ca(mu,nu)=x
      cb(mu,nu)=y
  45  b(mu,nu)=x+y
  42  continue

      eabij=zn(ii)*zn(jj)/dsqrt((coord(1,ii)-coord(1,jj))**2+
     $(coord(2,ii)-coord(2,jj))**2+(coord(3,ii)-coord(3,jj))**2)
      
      do 1 nu=llimi,iulimi
      do 1 mu=llimj,iulimj
       
      x=t(mu,nu)+z(mu,nu,ii) 
      y=t(mu,nu)+z(mu,nu,jj) 


      do 2 itau=llimi,iulimi
   2  x=x-aa(mu,itau,ii)*(t(itau,nu)+z(itau,nu,ii))

      do 3 itau=llimj,iulimj
   3  y=y-aa(nu,itau,jj)*(t(itau,mu)+z(itau,mu,jj))
      f=p(nu,mu)*(x+y)
      bsse=bsse+f
      oneel=oneel+f
   1  eabij=eabij+f  

      x=0.d0
      do 50 itau=llimi,iulimi
      do 51 mu=llimi,iulimi
 51   x=x+b(mu,itau)*z(itau,mu,jj)
      do 52 mu=llimj,iulimj
 52   x=x+b(mu,itau)*z(itau,mu,ii)
 50   continue 


      do 60 itau=llimj,iulimj
      do 64 mu=llimi,iulimi
 64   x=x+b(mu,itau)*z(itau,mu,jj)
      do 62 mu=llimj,iulimj
 62   x=x+b(mu,itau)*z(itau,mu,ii)
 60   continue 

      eabij=eabij+x
      oneel=oneel+x

      x=0.d0

      do 99 i=1,m
      do 99 j=1,m
   99 a(i,j)=aa(i,j,ii)


      do 100 kappa=llimi,iulimi
      kappa0=kappa-ishift
      do 100 iro=llimi,iulimi
      iro0=iro-ishift
      do 100 nu=llimj,iulimj
      nu0=nu-jshift
      do 100 itau=llimi,iulimi
      itau0=itau-ishift

      xx=0.d0
      do 128 ieta=llimi,iulimi
      ieta0=ieta-ishift
 128  xx=xx+a(nu,ieta)*gi(itau0,ieta0,kappa0,iro0)

 100  gt(itau0,nu0,kappa0,iro0)=xx

      do 400 kappa=llimi,iulimi
      kappa0=kappa-ishift
      do 400 iro=llimi,iulimi
      iro0=iro-ishift
      do 400 nu=llimi,iulimi
      nu0=nu-ishift
      do 400 itau=llimi,iulimi
      itau0=itau-ishift

      xx=0.d0
      do 428 ieta=llimi,iulimi
      ieta0=ieta-ishift
 428  xx=xx+a(nu,ieta)*gi(itau0,ieta0,kappa0,iro0)

 400  gt(itau0,nu0,kappa0,iro0)=xx


      do 101 kappa=llimi,iulimi
      kappa0=kappa-ishift
      do 101 iro=llimi,iulimi
      iro0=iro-ishift


      do 102 igam=llimi,iulimi
      igam0=igam-ishift
      do 102 nu=llimj,iulimj
      nu0=nu-jshift
          
      y=gg(igam0,nu0,kappa0,iro0)
      
      do 103 itau=llimi,iulimi
      itau0=itau-ishift
      y=y-a(igam,itau)*gt(itau0,nu0,kappa0,iro0)
  103 continue

      x=x+y*pp(kappa,igam,iro,nu)
  102 continue

      do 111 igam=llimj,iulimj
      igam0=igam-jshift
      do 111 nu=llimi,iulimi
      nu0=nu-ishift
          
      y=gg(igam0,nu0,kappa0,iro0)

      do 112 itau=llimi,iulimi
      itau0=itau-ishift
      y=y-a(igam,itau)*gt(itau0,nu0,kappa0,iro0)
  112 continue

      x=x+y*pp(kappa,igam,iro,nu)
  111 continue


      do 121 igam=llimj,iulimj
      igam0=igam-jshift
      do 121 nu=llimj,iulimj
      nu0=nu-jshift
          
      y=gg(igam0,nu0,kappa0,iro0)

      do 122 itau=llimi,iulimi
      itau0=itau-ishift
      y=y-a(igam,itau)*gt(itau0,nu0,kappa0,iro0)
  122 continue

      x=x+y*pp(kappa,igam,iro,nu)
  121 continue

  101 continue


      do 199 i=1,m
      do 199 j=1,m
  199 a(i,j)=aa(i,j,jj)


      do 600 kappa=llimj,iulimj
      kappa0=kappa-jshift
      kappa1=kappa-jshift0
      do 600 iro=llimj,iulimj
      iro0=iro-jshift
      iro1=iro-jshift0
      do 600 nu=llimi,iulimi
      nu0=nu-ishift
      do 600 itau=llimj,iulimj
      itau0=itau-jshift0

      xx=0.d0
      do 628 ieta=llimj,iulimj
      ieta0=ieta-jshift0
 628  xx=xx+a(nu,ieta)*gj(itau0,ieta0,kappa1,iro1)

 600  gt(itau0,nu0,kappa1,iro1)=xx

      do 700 kappa=llimj,iulimj
      kappa0=kappa-jshift
      kappa1=kappa-jshift0
      do 700 iro=llimj,iulimj
      iro0=iro-jshift
      iro1=iro-jshift0
      do 700 nu=llimj,iulimj
      nu0=nu-jshift
      do 700 itau=llimj,iulimj
      itau0=itau-jshift0

      xx=0.d0
      do 728 ieta=llimj,iulimj
      ieta0=ieta-jshift0
 728  xx=xx+a(nu,ieta)*gj(itau0,ieta0,kappa1,iro1)

 700  gt(itau0,nu0,kappa1,iro1)=xx


      do 200 kappa=llimj,iulimj
      kappa0=kappa-jshift
      do 200 iro=llimj,iulimj
      iro0=iro-jshift


      do 201 igam=llimj,iulimj
      igam0=igam-jshift
      do 201 nu=llimi,iulimi
      nu0=nu-ishift
          
      y=gg(igam0,nu0,kappa0,iro0)

      kappa1=kappa-jshift0
      iro1=iro-jshift0

      do 202 itau=llimj,iulimj
      itau0=itau-jshift0
      y=y-a(igam,itau)*gt(itau0,nu0,kappa1,iro1)
  202 continue

      x=x+y*pp(kappa,igam,iro,nu)
  201 continue


      do 211 igam=llimi,iulimi
      igam0=igam-ishift
      do 211 nu=llimj,iulimj
      nu0=nu-jshift
          
      y=gg(igam0,nu0,kappa0,iro0)

      do 212 itau=llimj,iulimj
      itau0=itau-jshift0
      y=y-a(igam,itau)*gt(itau0,nu0,kappa1,iro1)
  212 continue

      x=x+y*pp(kappa,igam,iro,nu)
  211 continue



      do 221 igam=llimi,iulimi
      igam0=igam-ishift
      do 221 nu=llimi,iulimi
      nu0=nu-ishift
          
      y=gg(igam0,nu0,kappa0,iro0)

      do 222 itau=llimj,iulimj
      itau0=itau-jshift0
      y=y-a(igam,itau)*gt(itau0,nu0,kappa1,iro1)
  222 continue

      x=x+y*pp(kappa,igam,iro,nu)
  221 continue

  200 continue

      eabij=eabij+0.5d0*x

      x=0.d0

      do 300 kappa=llimi,iulimi
      kappa0=kappa-ishift
      do 300 iro=llimj,iulimj
      iro0=iro-jshift
      
      do 310 itau=llimi,iulimi
      itau0=itau-ishift
      do 310 ieta=llimi,iulimi
      ieta0=ieta-ishift
  310 x=x+bb(kappa,itau,iro,ieta)*gg(kappa0,iro0,itau0,ieta0)  

     
      do 320 itau=llimi,iulimi
      itau0=itau-ishift
      do 320 ieta=llimj,iulimj
      ieta0=ieta-jshift
  320 x=x+bb(kappa,itau,iro,ieta)*gg(kappa0,iro0,itau0,ieta0)  


      do 330 itau=llimj,iulimj
      itau0=itau-jshift
      do 330 ieta=llimi,iulimi
      ieta0=ieta-ishift
  330 x=x+bb(kappa,itau,iro,ieta)*gg(kappa0,iro0,itau0,ieta0)  


      do 340 itau=llimj,iulimj
      itau0=itau-jshift
      do 340 ieta=llimj,iulimj
      ieta0=ieta-jshift
  340 x=x+bb(kappa,itau,iro,ieta)*gg(kappa0,iro0,itau0,ieta0)  

  300 continue

      eabij=eabij+x

      return
      end



      subroutine pmop(ca,nocca,cb,noccb,m,pa,pb,ndeckl)  
      implicit real*8(a-h,o-z)
        dimension ca(ndeckl,ndeckl),pa(ndeckl,ndeckl)
        dimension cb(ndeckl,ndeckl),pb(ndeckl,ndeckl)

       do 1 i=1,m
       do 1 j=i,m
       x=0.d0
       y=0.d0
       do 2 k=1,nocca
  2     x=x+ca(i,k)*ca(j,k)
       do 12 k=1,noccb
  12     y=y+cb(i,k)*cb(j,k)
       pa(j,i)=x
       pb(j,i)=y
       pa(i,j)=x
  1    pb(i,j)=y

       return
       end


